const SerialPort = require('serialport');
const Readline = require('@serialport/parser-readline');
let http = require('http');
let WebSocketServer = require('ws').Server;
let portws = 1234;
let host = '0.0.0.0';

let server = http.createServer();

// create a WebSocket Server on top of the HTTP server to deal with the WebSocket protocol
var wss = new WebSocketServer({
    server: server
});

var port = new SerialPort('/dev/ttyS4', {
    baudRate: 9600,
});

const parser = port.pipe(new Readline({delimiter: '\n'}));

// Read the port data
port.on("open", function () {
    console.log('open');
});


parser.on('data', data => {
    console.log(data);
    wss.broadcast(data);
});


// create a function to be able do broadcast messages to all WebSocket connected clients
wss.broadcast = function broadcast(message) {
    wss.clients.forEach(function each(client) {
        client.send(message);
    });
};



// http sever starts listening on given host and port.
server.listen(portws, host, function() {
    console.log('Listening on ' + server.address().address + ':' + server.address().port);
});

process.on('SIGINT', function() {
    process.exit(0);
});
